' TPG Usage Monitor v1.5
' by twig* (twig@genscripts.net)
'
' code based upon OptusNet "Yes" Usage Monitor
' feel free to email me about any queries
' please do not modify code and claim it is yours
'
' Refer to tpgUsageMonitor_readme.txt for more information.


' Configuration
username = "adslxxxx"  ' Your username
password = "xxxxxxxx"  ' Your password
quota_peak = 25    ' Your quota in GB, used for GetMegabytesPerDayRemaining()
quota_offpeak = 25 ' Your offpeak quota in GB, used for GetMegabytesPerDayRemainingOffPeak()


'[ there isnt really a need to edit anything below this line, unless tpg changes their page layout ]

' returns mbs downloaded in billing period
Function GetUsage
	GetUsage = Private_FindCacheValue("used_peak")
End Function


' returns mbs downloaded in billing period during offpeak hours
Function GetOffPeakUsage
	GetOffPeakUsage = Private_FindCacheValue("used_offpeak")
End Function


' returns usage charges on account
Function GetUsageCharges
	GetUsageCharges = Private_FindCacheValue("usageCharges")
End Function


' returns date of the end of billing period
Function GetBillingPeriodEnd
	GetBillingPeriodEnd = Private_FindCacheValue("billPeriodEnd")
End Function


' returns the days remaining for your billing period
' 1 day remaining = the day before your billing period resets.
Function GetBillingPeriodDaysRemaining
	Dim dateEnd, dateToday, dateSeconds

	dateEnd = Private_FindCacheValue("billPeriodEnd")
	dateSeconds = DateDiff("s", date, dateEnd)

	If (dateSeconds < 0) Then
		dateSeconds = 0
	End If

	GetBillingPeriodDaysRemaining = Int(dateSeconds / 86400) +1
End Function


' returns the megabytes per day remaining until the end of your billing period
Function GetMegabytesPerDayRemaining
	' subtract how many mb's are used so far
	' and divide that value by the number of days remaining in your billing period

	GetMegabytesPerDayRemaining = ((quota_peak * 1000) - Private_FindCacheValue("used_peak")) / GetBillingPeriodDaysRemaining()
End Function


' returns the megabytes per day remaining (off peak) until the end of your billing period
Function GetMegabytesPerDayRemainingOffPeak
	' subtract how many mb's are used so far
	' and divide that value by the number of days remaining in your billing period

	GetMegabytesPerDayRemainingOffPeak = ((quota_offpeak * 1000) - Private_FindCacheValue("used_offpeak")) / GetBillingPeriodDaysRemaining()
End Function


' returns amount owing/credit on account balance
Function GetAccountBalance
	GetAccountBalance = Private_FindCacheValue("balance")
End Function


' returns package/plan description
Function GetPackageType
	GetPackageType = Private_FindCacheValue("package")
End Function


' returns hours remaining
Function GetHoursRemaining
	GetHoursRemaining = Private_FindCacheValue("hours")
End Function


' returns download charges
Function GetDownloadCharges
	GetDownloadCharges = Private_FindCacheValue("downloadCharges")
End Function


' returns expiry date for account (i dont really know what its for, just might be useful to someone)
Function GetExpiryDate
	GetExpiryDate = Private_FindCacheValue("expiryDate")
End Function



'[ anything below this line does not require editing unless you know what you are doing! ]

' Get raw html from server and write it to a "cache" file
' NOTE: this page is only updated daily, so there is no point updating it every minute
Function RetrieveDataFromServer
	Randomize
	Dim objXMLHTTP, sHTML, sURL, sWrite

	sURL = "https://cyberstore.tpg.com.au/your_account/index.php?function=checkaccountusage&random=" & Rnd
	Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")

	' extract raw stats from server
	objXMLHTTP.Open "POST", sURL, False
	objXMLHTTP.setRequestHeader "Content-Type", "application/x-www-form-urlencoded"
	objXMLHTTP.Send "check_username=" + username + "&password=" + password
	sHTML = objXMLHTTP.responseText

	' write values to "cache" file
	sWrite = sWrite & "balance="		& Private_FindRawValue(sHTML, "<B>Account Balance:  </b>", "</td>") & VbCrlf
	sWrite = sWrite & "package="		& Private_FindRawValue(sHTML, "<b>Package Type:</b>", "</td>") & VbCrlf
	sWrite = sWrite & "hours="		& Private_FindRawValue(sHTML, "<b>Hours Left: </b>", "</td>") & VbCrlf
	sWrite = sWrite & "downloadCharges="	& Private_FindRawValue(sHTML, "<b>Downloads Charges:</b>", "</td>") & VbCrlf
	sWrite = sWrite & "expiryDate="		& Private_FindRawValue(sHTML, "<b>Expiry Date:</b>", "</td>") & VbCrlf
	sWrite = sWrite & "used_peak="		& Private_FindRawValue(sHTML, "Peak Downloads used: ", " MB") & VbCrlf
	sWrite = sWrite & "usageCharges="	& Private_FindRawValue(sHTML, "Usage Charges: ", "<BR>") & VbCrlf
	sWrite = sWrite & "billPeriodEnd="	& Private_FindRawValue(sHTML, "<b>Expiry Date:</b>", "</td>") & VbCrlf
	sWrite = sWrite & "used_offpeak=" 	& Private_FindRawValue(sHTML, "<br>Off-Peak Downloads used:", " MB</td>") & VbCrlf

	' for debugging
	'RetrieveDataFromServer = objXMLHTTP.responseText

	' open and write to file, then clean up
	Set fs = CreateObject("Scripting.FileSystemObject")
	Set f  = fs.CreateTextFile("tpg_usage.txt", true)
	f.write(sWrite)
	f.close
	Set f  = Nothing
	Set fs = Nothing
End Function


' returns value, found inside the whole chunk of html
' find = prefix before value
' tail = tail text after value, to know when to stop reading value
Function Private_FindRawValue(html, find, tail)
	Dim leftMark, rightmark

	leftMark = instr(html, find)
	leftMark = leftMark + len(find)
	rightMark = instr(leftMark, html, tail)
	Private_FindRawValue = trim(mid(html, leftMark, (rightMark - leftMark)))
End Function


' returns a value from the "cache" file
' find = info id
Function Private_FindCacheValue(find)
	Dim leftMark, rightmark, txt

	txt = Private_ReadCacheFile
	find = find & "="
	leftMark = instr(txt, find)
	leftMark = leftMark + len(find)
	rightMark = instr(leftMark, txt, VbCrlf)
	Private_FindCacheValue = trim(mid(txt, leftMark, (rightMark - leftMark)))
End Function


' Read the contents from the "cache" file
Function Private_ReadCacheFile
	Dim contents
	Set fs = CreateObject ("Scripting.FileSystemObject")

	If (fs.FileExists("tpg_usage.txt")) Then
		Set filePath = fs.GetFile("tpg_usage.txt")
		Set File = filePath.OpenAsTextStream (1, -2)
		contents = file.readall
		File.Close
		Set filePath = nothing
		Set fs = nothing
		Set File = nothing
	Else
		RetrieveDataFromServer()
		contents = Private_ReadCacheFile()
	End If

	Private_ReadCacheFile = contents
End Function